



     APX-Hosted i860(TM) CPU NATIVE BASIC SOFTWARE Package Release(N1.3)
                    Release Notes for the i860 Math Library

    1.0 INTRODUCTION

    These are the release notes for the APX-hosted i860 (TM) Math Library and
    the associated include file.  These release notes can also be found in the 
    doc directory in this package.  The release notes are organized as follows:

 
            1.0   INTRODUCTION
            2.0   Package Contents and Installation
            3.0   DOCUMENTATION

    The installation steps are described in the "Installation Instructions
    Supplement" in this package.


    2.0.  Package Contents 

    The contents of the package are: 

           doc        - directory containing these release notes (readme.m). 
           lib        - directory containing

                         . libfma.a --- The Scalar Math Library (SBS calling
                                                              convention). 

           inc        - directory containing 

                         . fmath.h  --- The associated include file for the 
                                        math library
    

    3.0 DOCUMENTATION  

    A Note on i860 Math Library:
    ----------------------------

    This library is performance-oriented at the expense of a minor loss of
    accuracy. The loss of significant binary digits is around 3 units for 
    normal values; for boundary conditions accuracy may be insufficient for 
    applications requiring extremely precise results. 

    There are no error checks performed in this library in view of execution
    performance. If input values to any of the functions are beyond the 
    specified range, the results are undefined.

    This library is about 20% - 50% faster than the standard compiler math 
    functions, depending upon the input values and the functions called.  
    Computations which require higher accuracy should use the standard 
    libraries that go with the compiler.  Applications which need high
    performance should use this library.



	466940 Rev. A					Page 2 of 4




    Please note that the Math library contains single as well as double 
    precision implementations of the various functions (eg, cos and cosf). 
    The single precision versions of these functions as well as  complex 
    functions do not exist in the C library (libca.a). Also, the function 
    sincos (single and double precision version) is included only in the Math
    library. All other double precision functions (eg, cos, sin,...) are 
    duplicated in the C library as well as in the i860 Math library. 
    All functions in the i860 Math library, except sincos (single and double
    precision version) exist in the FORTRAN libraries.



    3.1 DOCUMENTATION ERRATA


    Please make the following changes to the i860 Microprocessor Math Library
    Reference Manual (464411-02).



      Chapter 1, 
      Section 1.1.2 (Change reference to f16, f17 as follows)
      -------------

                    Single precision primitives return values in f8; double
                    precision primitives return values in f8:f9.


      Section 1.1.3 (Add the following text).
      -------------


                    C programmers can use single precision functions only
                    in ANSI mode, which is the default mode for the i860
                    C compiler.

                    Also, all C programmers MUST include the file fmath.h to 
                    ensure that the function prototypes are specified 
                    correctly to the compiler. Otherwise, the code generated
                    by the C compiler to access single precision routines 
                    will be incorrect.

                    If the default mode is not used, C programmers will need
                    to write intermediate assembly language routines to convert
                    the double precision parameter values generated by the 
                    compiler to the single precision values expected by the 
                    single precision routines.


                    All C programmers MUST pass input parameters to the complex
                    routine by address.





	466940 Rev. A					Page 3 of 4




      Section 1.1.7 (Add following section )
      -------------


                    The phrase QNaN means Quiet NaN.(For more details see
                    the i860 Programmer's Reference Manual).




      Chapter 2
      ---------
      Section 2.13  (Correction in the formula)
      ------------
      csqrt............................................Complex Square Root

            Change formulae for "r" as follows -

            r = sqrt (sqrt(x.re**2 + x.im**2))




      Chapter 2    (Add following routine)
      ---------
      cabs .......................................................absolute



             Computes


                    y <---  abs(x)


             where y is a real number and x is complex.


                    y = sqrt((x.re)^2 + (x.im)^2)




             Syntax:

                   C                            FORTRAN
                  ---                           -------
             # include < fmath.h >             COMPLEX x
               complex x;                      REAL y
               float y;                       
                                               y = cabs(x)
               y = cabs(&x);                   




	466940 Rev. A					Page 4 of 4
